{-# LANGUAGE TemplateHaskell, ScopedTypeVariables #-}
module Main where
import Data.Geniplate

uni :: [(Maybe Int, T Int, [Double])] -> [Int]
uni = $(universeBi 'uni)

uniT :: [(Maybe Int, T Int, [Double])] -> [Int]
uniT = $(universeBiT [ [t|Maybe Int|] ] 'uniT)

uni2 :: [B Bool] -> [Int]
uni2 = $(universeBi 'uni2)

uni3 :: [B Bool] -> [Bool]
uni3 = $(universeBi 'uni3)

data T a = T { x :: Int, y :: a } deriving (Show)

data B a = MT | Bin (B a) a Bool (B a) deriving (Show)

tree x = Bin (Bin MT x True MT) x False MT

trans :: (Int -> Int) -> [(Bool,T String)] -> [(Bool,T String)]
trans = $(transformBi 'trans)

trans1 :: (Bool -> Bool) -> B Char -> B Char
trans1 = $(transformBi 'trans1)

trans2 :: (Bool -> Bool) -> B Bool -> B Bool
trans2 = $(transformBi 'trans2)

main :: IO ()
main = do
    print $ uni  [(Just 12, T 1 2, [1.1]), (Just 345, T 3 4, [2.2]), (Nothing, T 5 6, [3.3])]
    print $ uniT [(Just 12, T 1 2, [1.1]), (Just 345, T 3 4, [2.2]), (Nothing, T 5 6, [3.3])]
    print $ uni2 $ [tree True, tree False]
    print $ uni3 $ [tree True, tree False]
    print $ trans (+1) [(True,T 1 "a"), (False,T 2 "b")]
    print $ trans1 not $ tree 'a'
    print $ trans2 not $ tree True
